inherit "/kernel/lib/physical";

void set_alias(string name, string value) {
  mapping aliases;

  aliases=query_property("aliases");
  if (!aliases) {
    aliases=([ ]);
  }
  if (value!="") {
    aliases[name]=value+" ";
  } else {
    aliases[name]=nil;
  }
  set_property("aliases", aliases);
}

mapping query_aliases() {
  return query_property("aliases");
}

string resolve_aliases(string command) {
  int i;
  mapping aliases;
  string *names;
  string name;
  string *values;
  int len;
  int no_space;

  aliases=query_property("aliases");
  if (aliases) {
    names=map_indices(aliases);
    values=map_values(aliases);
    for (i=0;i<sizeof(names);i++) {
      name=names[i];
      len=strlen(name);
      if (name[len-1..len-1]=="_") {
        name=name[..len-2];
        len=len-1;
        no_space=1;
      } else {
        no_space=0;
      }
      if (strlen(command)>=len && command[..len-1]==name) {
        if (!no_space) { /* The name didn't end in _, so must match entire word */
          if (strlen(command)==len || command[len..len]==" ") {
            command=values[i]+command[len..];
          }
        } else {
          command=values[i]+command[len..];
        }
      }
    }
  }
  return command;
}
