inherit physical "/kernel/lib/physical";

mapping verb_info;
string *food_descs, *drink_descs;
int left;

int consume(object actor, string verb, object *x, string y) {
  int amount;
  mixed *info;

  info=verb_info[verb];
  /* If it isn't in there, there's something badly wrong - but we'll
     check anyway */
  if (info) {
    amount=info[2];
    if (amount==-1) {
      amount=left;
    }
    if (amount==-2) {
      if (left<8) {
        amount=left;
      } else {
        amount=left-1;
      }
    }
    if (left<=amount) {
      send_event(actor, "action", "You", verb+" the last of "+
                 this_object()->query_art_name()+".");
      send_event(actor->near_objects()-({actor}), "action", 
                 actor->query_name(), info[0]+" the last of "+
                 this_object()->query_art_name()+".");
      if (this_object()->query_property("poison")==1) {
        call_out("do_morgue", 1, actor);
      } else {
        destruct_object(this_object());
      }
    } else {
      send_event(actor, "action", "You", verb+" some of "+
                 this_object()->query_art_name()+".");
      send_event(actor->near_objects()-({actor}), "action", 
                 actor->query_name(), info[0]+" some of "+
                 this_object()->query_art_name()+".");
      left=left-amount;
      if (this_object()->query_property("poison")==1) {
        if (random(10)==0) {
          call_out("do_morgue", 1, actor);
        } else {
          actor->send_message("You don't feel so good.  Did that "+
                                    "taste right?\n");
        }
      }
    }
  }
}

string query_description() {
  string result;
  int fraction;

  fraction=10-(left*10/query_property("food_size"));
  result=::query_description();
  if (query_property("food_type")==1) {
    result+="  It "+food_descs[fraction]+".";
  } else {
    result+="  It "+drink_descs[fraction]+".";
  }
  return result;
}

string query_raw_description() {
  return ::query_description();
}

void set_size(int size) {
  set_property("food_size", size);
  left=size;
}

void set_left(int size) {
  left=size;
}

int query_left() {
  return left;
}

/* void do_morgue(object corpse) {
  tell_object(corpse,"A slow pain erupts in your guts and the world goes swimmy around you. "+
	"You black out. Perhaps that wasn't the best thing in the world to eat.\n");
  tell_room(environment(corpse),corpse->query_pronoun(PRON_SUBJ)+" clutches "+corpse->query_pronoun(PRON_POSS)+" stomach "+
	"and groans. "+capitalize(corpse->query_pronoun(PRON_SUBJ))+" collapses and "+corpse->query_pronoun(PRON_POSS)+
        " body is taken away on a litter.\n",corpse);
  corpse->move("/rooms/morgue", this_object());
  destruct_object(this_object());
} */

void create() {
  physical::create();
  set_size(1);
  set_property("food_type", 1);
  /* key is the verb.  first item is the second person form of the verb (for
     messages).  Second item is 1 for 'eating' verbs, 2 for 'drinking' verbs.
     Third item is the size of consumption.  -1 means 'all', -2 means 'all if
     there's less than 8 left, all but one otherwise'. */
  verb_info=(["eat":({"eats", 1, 3}), "gobble":({"gobbles", 1, -1}),
              "munch":({"munches", 1, 2}), "chomp":({"chomps", 1, 4 }),
              "nibble":({"nibbles", 1, 1}),
	      "drink":({"drinks", 2, 3}), "gulp":({"gulps", 2, 5}),
              "sip":({"sips", 2, 1}), "quaff":({"quaffs", 2, -2}),
              "slurp":({"slurps", 2, 7}), "scull":({"sculls", 2, -1}) ]);
  food_descs=({"hasn't been started yet","is slightly nibbled","is partly gnawed","has a chunk missing","is nearly half gone","is half finished","has nearly half of it left","is over two-thirds gone","has a few bites left to go","has just enough for a mouthful left","is down to crumbs"});
  drink_descs=({"is still full","doesn't quite reach the top","has a few sips missing","is about three quarters full","is nearly half gone","is half full, or is that half empty","is slightly more than half gone","is about a quarter full","has a few mouthfuls left","has a few dregs at the bottom","is slightly wet on the inside"});
}

void init(object person) {
  int food_type;
  int i;

  ::init(person);
  food_type=query_property("food_type");
  for (i=0;i<sizeof(map_indices(verb_info));i++) {
    if (map_values(verb_info)[i][1]==food_type) {
      person->add_grammar(map_indices(verb_info)[i], "%thisobject", "consume", ({ 0 }));
    }
  }
}
