#include <kernel/physical.h>

inherit "/kernel/lib/arrays";

string name_list(object *objs, object you, object actor, int type, int to_actor) {
  /* Returns a text list of the names of the objects.  type and to_actor
     specify what happens to the names of 'you' and 'actor' type=0:normal,
     type=1:possessive */
  string *result;
  int i;

  result=({ });
  if (!objs || sizeof(objs)==0) {
    result=({ "nothing" });
  } else {
    if (member_array(actor, objs)==-1) {
      actor=nil;
    }
    if (member_array(you, objs)==-1) {
      you=nil;
    }
    objs-=({ you, actor });
    for (i=0;i<sizeof(objs);i++) {
      if (type==1 && i==sizeof(objs)-1) {
        result+=({ objs[i]->query_poss_art_name() });
      } else {
        result+=({ objs[i]->query_art_name() });
      }
    }
    if (you) {
      if (type==1) {
        result+=({ "your" });
      } else {
	if (you==actor) {
          result+=({ "yourself" });
	} else {
          result+=({ "you" });
	}
      }
    }
    if (actor && actor!=you) {
      if (to_actor) {
	if (type==1) {
	  result+=({ "your" });
	} else {
	  result+=({ "yourself" });
	}
      } else {
        if (type==1) {
          result+=({ actor->query_pronoun(PRON_POSS) });
        } else {
          result+=({ actor->query_pronoun(PRON_REFL) });
	}
      }
    }
  }
  switch (sizeof(result)) {
    case 1: return result[0];
    case 2: return implode(result, " and ");
    default: return implode(result[..sizeof(result)-2], ", ")+" and "+result[sizeof(result)-1];
  }
}
