inherit "/kernel/lib/physical";

static string response;
static string *cities;
static string result;
static object *askers;
static int pending;

void create() {
  ::create();
  set_name("small networked digital clock");
  set_ids("clock");
  askers=({ });
}

void tell_askers(string message) {
  int i;

  for (i=0;i<sizeof(askers);i++) {
    if (askers[i]) {
      askers[i]->send_message(message);
    }
  }
  askers=({ });
}

void close(int flag) {
  string *lines;
  string date, time;
  int i;
  string place;

  lines=explode(response, "\n");
  for (i=0; i<sizeof(lines); i++) {
    if (sscanf(lines[i], "<TR><TH>Current time</TH><TD><b>%s at %s</b></TD></TR>", date, time)==2) {
      place="";
      /* This is a really ugly way of doing it... one of the two previous
lines
         has the city, and it can be in one of three formats.  So check all of
         them, and any that match will fill in the info */
      sscanf(lines[i-2], "<TR><TH ALIGN=CENTER COLSPAN=2><font size=7>%s</font></TH></TR>", place);
      sscanf(lines[i-2], "<TR><TH ALIGN=CENTER COLSPAN=2><font size=7>%s, %*s</font></TH></TR>", place);
      sscanf(lines[i-2], "<TR><TH ALIGN=CENTER COLSPAN=2><font size=7>%s, %*s</font><br>%*s", place);

      sscanf(lines[i-1], "<TR><TH ALIGN=CENTER COLSPAN=2><font size=7>%s</font></TH></TR>", place);
      sscanf(lines[i-1], "<TR><TH ALIGN=CENTER COLSPAN=2><font size=7>%s, %*s</font></TH></TR>", place);
      sscanf(lines[i-1], "<TR><TH ALIGN=CENTER COLSPAN=2><font size=7>%s, %*s</font><br>%*s", place);
      if (place!="") {
        result+=place+": ";
      } else {
        result+="Somewhere: ";
      }
      result+=date+" "+time+"\n";
    }
  }
  pending--;
  if (!pending) {
    if (result!="") {
      tell_askers("The clock jumps onto your shoulder and whispers:\n"+result);
    } else {
      tell_askers("The clock gives up.\n");
    }
    askers=({ });
  } else {
    connect("209.68.24.127", 80, "tcp");
  }
}

void receive_message(string line) {
  response+=line;
}

void open() {
  response="";
  send_message("GET /worldclock/results.html?query="+cities[0]+"\n");
  cities-=({cities[0]});
}

void fetch(string city) {
  cities+=({city});
  if (!pending) {
    connect("209.68.24.127", 80, "tcp");
  }
  pending++;
}

void get_info() {
  string *data;
  int i;

  pending=0;
  response="";
  cities=({ });
  result="";
  data=explode(read_file("/data/clock.dat"), "\n");
  for (i=0;i<sizeof(data);i++) {
    data[i]=replace_string(data[i], ",", "%2c");
    data[i]=replace_string(data[i], " ", "+");
    fetch("%22"+data[i]+"%22");
  }
}

string query_description() {
  askers+=({this_user()});
  if (!pending) {
    get_info();
  }
  return "The clock thinks for a while...";
}
