inherit "/kernel/lib/sprintf";
inherit "/kernel/lib/arrays";
inherit "/kernel/lib/files";

object wardrobe;
mixed *data;
string file_name;
object owner;
int index;

void say(string str) {
  owner->send_message(sprintf("%*=s", owner->query_cols(), str)+"\n");
}

void prompt() {
  owner->send_message("] ");
}

void load_data(string f_name) {
  string *lines;
  int i;
  string *ids;
  string name, description;

  lines=explode(read_file(f_name), "\n");
  i=0;
  while (i<sizeof(lines)) {
    ids=explode(lines[i++], "#");
    name=lines[i++];
    description="";
    while (i<sizeof(lines) && lines[i]!="") {
      if (description!="") {
        description+=" ";
      }
      description+=lines[i++];
    }
    data+=({ ({ ids, name, description }) });
    i++;
  }
}

void save_data(string f_name) {
  int i;

  ensure_path(f_name);
  remove_file(f_name);
  for (i=0;i<sizeof(data);i++) {
    write_file(f_name, implode(data[i][0], "#")+"\n");
    write_file(f_name, data[i][1]+"\n");
    write_file(f_name, data[i][2]+"\n\n");
  }
}

void new_clothing(object actor, object caller) {
  mixed dir_info;

  wardrobe=caller;
  file_name=actor->query_home_dir()+"/data/clothes.dat";
  owner=actor;
  dir_info=get_dir(file_name);
  data=({ });
  if (sizeof(dir_info[0])) {
    load_data(file_name);
  }
  data+=({ ({ ({ }), "", ""}) });
  index=sizeof(data)-1;
  say("Start with the ids.  These are the phrases (usually single words) "+
      "that people can use to refer to this object.");
  say("Enter one id on each line, and then a blank line to finish.");
  prompt();
  input_to("get_ids");
}

void get_ids(string str) {
  if (str!="") {
    data[index][0]+=({str}); 
    prompt();
    input_to("get_ids");
  } else {
    say("Now enter the name.");
    prompt();
    input_to("get_name");
  }
}

void get_name(string str) {
  data[index][1]=str;
  say("Now enter the description.  It can be several lines long - enter a "+
      "blank line to finish.");
  prompt();
  input_to("get_description");
}

void get_description(string str) {
  if (str!="") {
    if (data[index][2]!="") {
      data[index][2]+=" ";
    }
    data[index][2]+=str;
    prompt();
    input_to("get_description");
  } else {
    save_data(file_name);
    wardrobe->uninit(owner);
    wardrobe->init(owner);
    destruct_object(this_object());
  }
}
