inherit physical "/kernel/lib/physical";

void create() {
  ::create();
  set_ids(({ "mirror", "flame", "looking-glass", "glass" }));
  set_name("large looking-glass");
  set_description("It's a large looking-glass, covering most of the north wall.  In "+
	   "it you can see a shadowy reflection of the room, almost, but not "+
	   "quite the same...");
}

void init(object person) {
  physical::init(person);
  person->add_grammar("n", "", "do_it", ({ }), 1);
  person->add_grammar("north", "", "do_it", ({ }), 1);
  person->add_grammar("enter", "%thisobject", "do_enter", ({ 0 }), 1);
}

void do_it(object actor, string verb) {
  if (explode(object_name(actor->connection_object()), "#")[0]=="/kernel/obj/tunnel") {
    actor->save_user();
    actor->send_message("See you later...\n");
    actor->kill_me();
  } else {
    actor->send_message("What kind of an idiot walks into mirrors?\n");
  }
}

void do_enter(object actor, string verb, object *x, string y) {
  do_it(actor, verb);
}
